package com.bweb.controller.order;

import com.bweb.controller.goods.GoodsController;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.hfkj.common.security.SessionObject;
import com.hfkj.common.security.UserCenter;
import com.hfkj.common.utils.ResponseMsgUtil;
import com.hfkj.model.ResponseData;
import com.hfkj.model.SecUserSessionObject;
import com.hfkj.service.goods.BsOrderGoodsService;
import com.hfkj.sysenum.SecUserObjectTypeEnum;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.util.HashMap;
import java.util.Map;

@Controller
@RequestMapping(value="/orderGoods")
@Api(value="实物订单管理")
public class BsOrderGoodsController {

    private static final Logger log = LoggerFactory.getLogger(BsOrderGoodsController.class);

    @Resource
    private BsOrderGoodsService bsOrderGoodsService;

    @Resource
    private UserCenter userCenter;


    @RequestMapping(value="/getListGoods",method = RequestMethod.GET)
    @ResponseBody
    @ApiOperation(value = "查询列表")
    public ResponseData getListGoods(@RequestParam(value = "logisticsNo" , required = false) String logisticsNo,
                                     @RequestParam(value = "goodsType" , required = false) Long goodsType,
                                     @RequestParam(value = "goodsBrand" , required = false) Long goodsBrand,
                                     @RequestParam(value = "orderNo" , required = false) String orderNo,
                                     @RequestParam(value = "childOrderNo" , required = false) String childOrderNo,
                                     @RequestParam(value = "userPhone" , required = false) String userPhone,
                                     @RequestParam(value = "goodsSpecsName" , required = false) String goodsSpecsName,
                                     @RequestParam(value = "goodsName" , required = false) String goodsName,
                                     @RequestParam(value = "payType" , required = false) Integer payType,
                                     @RequestParam(value = "status" , required = false) Integer status,
                                     @RequestParam(value = "pageNum" , required = true) Integer pageNum,
                                     @RequestParam(value = "pageSize" , required = true) Integer pageSize, HttpServletRequest request) {
        try {

            SessionObject sessionObject = userCenter.getSessionObject(request);
            SecUserSessionObject userModel = (SecUserSessionObject) sessionObject.getObject();

            Map<String , Object> map = new HashMap<>();

            if (userModel.getAccount().getObjectType().equals(SecUserObjectTypeEnum.type2.getCode())) {
                map.put("merId", userModel.getAccount().getId());
            }

            map.put("logisticsNo", logisticsNo);
            map.put("goodsType", goodsType);
            map.put("goodsBrand", goodsBrand);
            map.put("orderNo", orderNo);
            map.put("childOrderNo", childOrderNo);
            map.put("userPhone", userPhone);
            map.put("goodsSpecsName", goodsSpecsName);
            map.put("goodsName", goodsName);
            map.put("payType", payType);
            map.put("status", status);

            PageHelper.startPage(pageNum, pageSize);
            return ResponseMsgUtil.success(new PageInfo<>(bsOrderGoodsService.getList(map)));

        } catch (Exception e) {
            log.error("error!",e);
            return ResponseMsgUtil.exception(e);
        }
    }

}
